<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>celNNActivationFunc Class Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-static-methods">Static Protected Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">celNNActivationFunc Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="celNNActivationFunc" --><!-- doxytag: inherits="csRefCount" -->
<p>Abstract class representing an activation function callback for the neural network property class.  
 <a href="classcelNNActivationFunc.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="neuralnet_8h_source.html">propclass/neuralnet.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for celNNActivationFunc:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classcelNNActivationFunc.png" usemap="#celNNActivationFunc_map" alt=""/>
  <map id="celNNActivationFunc_map" name="celNNActivationFunc_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefCount.html" alt="csRefCount" shape="rect" coords="0,0,180,24"/>
<area href="classcelAtanActivationFunc.html" title="An arc-tangent activation function for the neural network property class." alt="celAtanActivationFunc&lt; T &gt;" shape="rect" coords="190,112,370,136"/>
<area href="classcelCosActivationFunc.html" title="A cosine activation function for the neural network property class." alt="celCosActivationFunc&lt; T &gt;" shape="rect" coords="190,168,370,192"/>
<area href="classcelElliottActivationFunc.html" title="An Elliott activation function for the neural network property class." alt="celElliottActivationFunc&lt; T &gt;" shape="rect" coords="190,224,370,248"/>
<area href="classcelExpActivationFunc.html" title="An exponential activation function for the neural network property class." alt="celExpActivationFunc&lt; T &gt;" shape="rect" coords="190,280,370,304"/>
<area href="classcelGaussActivationFunc.html" title="An gaussian activation function for the neural network property class." alt="celGaussActivationFunc&lt; T &gt;" shape="rect" coords="190,336,370,360"/>
<area href="classcelInvActivationFunc.html" title="A reciprocal activation function for the neural network property class." alt="celInvActivationFunc" shape="rect" coords="190,392,370,416"/>
<area href="classcelLogActivationFunc.html" title="A logarithmic activation function for the neural network property class." alt="celLogActivationFunc&lt; T &gt;" shape="rect" coords="190,448,370,472"/>
<area href="classcelNopActivationFunc.html" title="An identity activation function for the neural network property class." alt="celNopActivationFunc&lt; T &gt;" shape="rect" coords="190,504,370,528"/>
<area href="classcelSigActivationFunc.html" title="A sigmoid activation function for the neural network property class." alt="celSigActivationFunc&lt; T &gt;" shape="rect" coords="190,560,370,584"/>
<area href="classcelSinActivationFunc.html" title="A sine activation function for the neural network property class." alt="celSinActivationFunc&lt; T &gt;" shape="rect" coords="190,616,370,640"/>
<area href="classcelSqrActivationFunc.html" title="A squaring activation function for the neural network property class." alt="celSqrActivationFunc&lt; T &gt;" shape="rect" coords="190,672,370,696"/>
<area href="classcelStepActivationFunc.html" title="A threshold activation function for the neural network property class." alt="celStepActivationFunc&lt; T &gt;" shape="rect" coords="190,728,370,752"/>
<area href="classcelTanhActivationFunc.html" title="A hyperbolic-tangent activation function for the neural network property class." alt="celTanhActivationFunc&lt; T &gt;" shape="rect" coords="190,784,370,808"/>
</map>
 </div></div>

<p><a href="classcelNNActivationFunc-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelNNActivationFunc.html#af6fa30c106acfc347c3c4d9802e34c90">Function</a> (<a class="el" href="structcelData.html">celData</a> &amp;data)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The callback method. Performs the activation function on the data.  <a href="#af6fa30c106acfc347c3c4d9802e34c90"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual celDataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelNNActivationFunc.html#a55cf5cd8747b85c740ef50664c59ab50">GetDataType</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the type of data upon which this function operates.  <a href="#a55cf5cd8747b85c740ef50664c59ab50"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelNNActivationFunc.html#a491588dcfe705ca49ef29059c0d84ef9">~celNNActivationFunc</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#a491588dcfe705ca49ef29059c0d84ef9"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-static-methods"></a>
Static Protected Member Functions</h2></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">static celDataType&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classcelNNActivationFunc.html#a996ea992143b42b31e19b069ff04dd61">DataType</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convenience template for subclasses of <a class="el" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>.  <a href="#a996ea992143b42b31e19b069ff04dd61"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">static const T &amp;&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classcelNNActivationFunc.html#aa32d09db692e0326f60f416a351dc486">GetFrom</a> (const <a class="el" href="structcelData.html">celData</a> &amp;input)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convenience template for subclasses of <a class="el" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>.  <a href="#aa32d09db692e0326f60f416a351dc486"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Abstract class representing an activation function callback for the neural network property class. </p>
<p>This is passed to the <a class="el" href="structiPcNeuralNet.html#a3ea5bf4ad84cf46b611c0f7ec68f6a87" title="Sets the activation function of the neural network.">iPcNeuralNet::SetActivationFunc()</a> method, and is used as the activation function for the nodes in the network. The user of the property class can use one of the supplied implementations of celActivationFunc, or they can implement their own.</p>
<p>The supplied implementations can also be selected using pcneuralnet's "SetActivationFunc" action. See the specific implementation class for the "cel.activationFunc." string ID to use. </p>

<p>Definition at line <a class="el" href="neuralnet_8h_source.html#l00202">202</a> of file <a class="el" href="neuralnet_8h_source.html">neuralnet.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a491588dcfe705ca49ef29059c0d84ef9"></a><!-- doxytag: member="celNNActivationFunc::~celNNActivationFunc" ref="a491588dcfe705ca49ef29059c0d84ef9" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classcelNNActivationFunc.html#a491588dcfe705ca49ef29059c0d84ef9">celNNActivationFunc::~celNNActivationFunc</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destructor. </p>

<p>Definition at line <a class="el" href="neuralnet_8h_source.html#l00212">212</a> of file <a class="el" href="neuralnet_8h_source.html">neuralnet.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a996ea992143b42b31e19b069ff04dd61"></a><!-- doxytag: member="celNNActivationFunc::DataType" ref="a996ea992143b42b31e19b069ff04dd61" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">celDataType <a class="el" href="classcelNNActivationFunc.html#a996ea992143b42b31e19b069ff04dd61">celNNActivationFunc::DataType</a>&lt; float &gt; </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inline, static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convenience template for subclasses of <a class="el" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>. </p>
<p>Implementations of <a class="el" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a> may, if they wish, use this method template to translate a C++ type declarator into a CEL_DATA constant.</p>
<p>The template is specialised for all integer types and float (not double). Attempting to use any other type for the template parameter will result in a linker error. </p>

<p>Definition at line <a class="el" href="neuralnet_8h_source.html#l00280">280</a> of file <a class="el" href="neuralnet_8h_source.html">neuralnet.h</a>.</p>

</div>
</div>
<a class="anchor" id="af6fa30c106acfc347c3c4d9802e34c90"></a><!-- doxytag: member="celNNActivationFunc::Function" ref="af6fa30c106acfc347c3c4d9802e34c90" args="(celData &amp;data)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelNNActivationFunc.html#af6fa30c106acfc347c3c4d9802e34c90">celNNActivationFunc::Function</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcelData.html">celData</a> &amp;&#160;</td>
          <td class="paramname"><em>data</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The callback method. Performs the activation function on the data. </p>

<p>Implemented in <a class="el" href="classcelSigActivationFunc.html#af62931191f159b46a26bda17c2fe84b3">celSigActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelElliottActivationFunc.html#a21e2104021954e11021b88606c298f45">celElliottActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelCosActivationFunc.html#af8558a3b6552b0e5330f3e2cdd082abe">celCosActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelSinActivationFunc.html#ac5cd64b71322cdff164fadd3889ba512">celSinActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelGaussActivationFunc.html#aed9e13d5d29ba0d123a5265db8d3fecf">celGaussActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelSqrActivationFunc.html#a4a9c580f748536ee363f4e4c1a0c2f9f">celSqrActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelInvActivationFunc.html#a0e4717ab9b331fa1066290db579cf292">celInvActivationFunc</a>, <a class="el" href="classcelExpActivationFunc.html#acfc526896a7e2951ed0f05cf6f83dfdd">celExpActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelTanhActivationFunc.html#ad3ce715c2b152a23775c3170c110fbc4">celTanhActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelAtanActivationFunc.html#a95c8a9664b32d3e5d48922d3b8b2b167">celAtanActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelLogActivationFunc.html#a4a40967497faec4395f56d738bb68729">celLogActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelStepActivationFunc.html#aed07d287a04476a44ff50833f16ce326">celStepActivationFunc&lt; T &gt;</a>, and <a class="el" href="classcelNopActivationFunc.html#a36f51435796ae6a0083859c9329145b3">celNopActivationFunc&lt; T &gt;</a>.</p>

</div>
</div>
<a class="anchor" id="a55cf5cd8747b85c740ef50664c59ab50"></a><!-- doxytag: member="celNNActivationFunc::GetDataType" ref="a55cf5cd8747b85c740ef50664c59ab50" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual celDataType <a class="el" href="classcelNNActivationFunc.html#a55cf5cd8747b85c740ef50664c59ab50">celNNActivationFunc::GetDataType</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the type of data upon which this function operates. </p>

<p>Implemented in <a class="el" href="classcelSigActivationFunc.html#a4bd265d016a0779c29becbeff6560904">celSigActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelElliottActivationFunc.html#afc4156c87d48103371ffa00a74a63e4b">celElliottActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelCosActivationFunc.html#a04d86f935e737b00e90aa1ebd4b6a543">celCosActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelSinActivationFunc.html#a9536b620b8998219094d15bed7558cf7">celSinActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelGaussActivationFunc.html#a5d385afc96a9017e4e28523709fd32db">celGaussActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelSqrActivationFunc.html#a08cd34060e403a2291f1ff9fbd193d5e">celSqrActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelInvActivationFunc.html#a25a4f771f246a496ad65658991c9c2e5">celInvActivationFunc</a>, <a class="el" href="classcelExpActivationFunc.html#a68bc03d543780392012499324f4864be">celExpActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelTanhActivationFunc.html#af462a53e6c5f342df6492646d1518414">celTanhActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelAtanActivationFunc.html#a6b82ce4fd8985d91ae4c61c2b2ff6a08">celAtanActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelLogActivationFunc.html#a86dd194b3c115f5c98c6ba1df1e613cf">celLogActivationFunc&lt; T &gt;</a>, <a class="el" href="classcelStepActivationFunc.html#aa604fe959af37bfc056c106f1d11360b">celStepActivationFunc&lt; T &gt;</a>, and <a class="el" href="classcelNopActivationFunc.html#ae4a4f686299f728df719a29f87f0186e">celNopActivationFunc&lt; T &gt;</a>.</p>

</div>
</div>
<a class="anchor" id="aa32d09db692e0326f60f416a351dc486"></a><!-- doxytag: member="celNNActivationFunc::GetFrom" ref="aa32d09db692e0326f60f416a351dc486" args="(const celData &amp;input)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> &amp; <a class="el" href="classcelNNActivationFunc.html#aa32d09db692e0326f60f416a351dc486">celNNActivationFunc::GetFrom</a>&lt; <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> &gt; </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structcelData.html">celData</a> &amp;&#160;</td>
          <td class="paramname"><em>input</em></td><td>)</td>
          <td><code> [inline, static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convenience template for subclasses of <a class="el" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>. </p>
<p>Implementations of <a class="el" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a> may, if they wish, use this method template to extract data from a <a class="el" href="structcelData.html" title="Typed data for CEL.">celData</a> structure in a generic way, since <a class="el" href="structcelData.html" title="Typed data for CEL.">celData</a> does not provide its own generic Get() method.</p>
<p>The template is specialised for all integer types and float (not double). Attempting to use any other type for the template parameter will result in a linker error. </p>

<p>Definition at line <a class="el" href="neuralnet_8h_source.html#l00244">244</a> of file <a class="el" href="neuralnet_8h_source.html">neuralnet.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>propclass/<a class="el" href="neuralnet_8h_source.html">neuralnet.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
